#include <stdint.h>

__declspec(dllexport) uint32_t mod_type=0x32303536;
__declspec(dllexport) uint8_t *mod_name="Fake6502";
__declspec(dllexport) uint8_t *mod_pref="fake6502";
__declspec(dllexport) uint8_t *mod_vers="1.1";
__declspec(dllexport) uint8_t *mod_copr="Copyright 2011 Mike Chambers\n"
                                        "Copyright 2017 Steve Nickolas";

void (*cpuwrite)(uint16_t, uint8_t);
uint8_t (*cpuread)(uint16_t);
int8_t (*cpuloop)(void);

static int cycles;

__declspec(dllexport) void fake6502_cpureset(void)
{
 reset6502();
}

__declspec(dllexport) void fake6502_cpurun(void)
{
 while (1)
 {
  exec6502(cycles);
  x=cpuloop();
  if (x==-1) break;
 }
}

__declspec(dllexport) void fake6502_cpuseta(uint8_t val)
{
 a=val;
}

__declspec(dllexport) void fake6502_cpusetx(uint8_t val)
{
 x=val;
}

__declspec(dllexport) void fake6502_cpusety(uint8_t val)
{
 y=val;
}

__declspec(dllexport) void fake6502_cpusets(uint8_t val)
{
 sp=val;
}

__declspec(dllexport) void fake6502_cpusetp(uint8_t val)
{
 status=val;
}

__declspec(dllexport) void fake6502_cpusetpc(uint16_t val)
{
 pc=val;
}

__declspec(dllexport) void fake6502_cpusetrate(int val)
{
 cycles=val;
}

__declspec(dllexport) uint8_t fake6502_cpugeta(void)
{
 return a;
}

__declspec(dllexport) uint8_t fake6502_cpugetx(void)
{
 return x;
}

__declspec(dllexport) uint8_t fake6502_cpugety(void)
{
 return y;
}

__declspec(dllexport) uint8_t fake6502_cpugets(void)
{
 return sp;
}

__declspec(dllexport) uint8_t fake6502_cpugetp(void)
{
 return status;
}

__declspec(dllexport) uint16_t fake6502_cpugetpc(void)
{
 return pc;
}

__declspec(dllexport) int fake6502_cpugetrate(void)
{
 return cycles;
}

__declspec(dllexport) void fake6502_cpuinit(void (*v_cpuwrite)(uint16_t, uint8_t),
                                          uint8_t (*v_cpuread)(uint16_t),
                                          int8_t (*v_cpuloop)(void))
{
 cpuwrite=v_cpuwrite;
 cpuread=v_cpuread;
 cpuloop=v_cpuloop;
}
